// set this to the key you wish to use to toggle the beacondisplay
$Beacon::Key = "p";

// set this to the modifier you want to use with the key (ie "alt" or "control" or "shift")
$Beacon::Modifier = "shift";

// Load support scripts from my attached copy if they havent already been loaded.
if (!exec("writer\\include.cs"))
	if (!exec("presto\\include.cs"))
		exec("autobeacon\\support\\include.cs");

if ((!included("presto\\event.cs")) || (!included("writer\\event.cs"))) {
	include("autobeacon\\support\\event.cs");
}

if ((!included("presto\\events.cs")) || (!included("writer\\events.cs"))) {
	include("autobeacon\\support\\presto\\events.cs");
}

if (!included("crunchy\\events.cs")) {
	include("autobeacon\\support\\crunchy\\events.cs");
}
$Beacon::Loaded = false;
$Beacon::On = true;

function loadBeaconGui(%filename) {	
	if (!$Beacon::On) return;
	
	DeleteBeacons();

	echo("BEACON - loading: " @ %filename);
	if (isfile(%filename)) {
		echo("BEACON - File found!");
		%beaconset = loadobject("BeaconSet", %filename);
		%beacons = group::objectcount(%beaconset);
		
		$Beacon::Loaded = true;
		echo("BEACON - loaded as object " @ %beaconset @ ", " @ %beacons @ " beacons in set.");
		$AutoBeacon::NumBeacons = 0;
		for (%i = 0; %i < %beacons; %i++) {
			%thisbeacon = group::getObject(%beaconset, %i);
			echo("BEACON - handling number " @ %i @ " (" @ %thisbeacon @ ").");
			addtoset(725, %thisbeacon);
			$AutoBeacon::NumBeacons++;
			$AutoBeacon::Beaconlist[%i] = %thisbeacon;
		}
		deleteobject(%beaconset);
	}
}

function DeleteBeacons() {
	if ($AutoBeacon::NumBeacons) {
		echo("BEACON - Deleting previous beacons.");
		$Beacon::Loaded = false;
		for (%i = 0; %i < $AutoBeacon::NumBeacons; %i++) {
			if ($AutoBeacon::Beaconlist[%i]) {
				deleteobject($AutoBeacon::Beaconlist[%i]);
				echo("BEACON - Deleting beacon number" @ %i @ " (" @ $AutoBeacon::Beaconlist[%i] @ ").");
				$AutoBeacon::Beaconlist[%i] = false;
			}
		}
		$AutoBeacon::NumBeacons = 0;
	}
}


if ((included("presto\\events.cs") || included("writer\\events.cs") || included("crunchy\\events.cs")) && included("crunchy\\events.cs")) {
	function AutoBeacon::OnLoad(%server, %missionName, %missionType) {
		loadbeacongui("config\\autobeacon\\" @ %missionname @ "team" @ client::getteam(getmanagerid()) @ "beacons.gui");
	}
	
	event::attach(eventMissionInfo, Autobeacon::OnLoad);
}
else {

	function remoteMInfo(%server, %missionName)
	{
		echo("Server: ",%server);

		if(%server == 2048)
		{
			%file = "missions\\" @ %missionName @ ".dsc";
			$MDESC::Type = "";
			$MDESC::Text = "";
			if(File::findFirst(%file) != "")
				exec(%file);
			$ServerMission = %missionName;
			$ServerText = $MDESC::Text;
			$ServerMissionType = $MDESC::Type;
			if(isObject(LobbyGui))
				LobbyGui::onOpen();  // update lobby screen text.

		}
	
		loadbeacongui("config\\autobeacon\\" @ %missionname @ "team" @ client::getteam(getmanagerid()) @ "beacons.gui");
	}
}


function AutoBeacon::OnLoad(%server, %missionName, %missionType) {
	loadbeacongui("config\\autobeacon\\" @ %missionname @ "team" @ client::getteam(getmanagerid()) @ "beacons.gui");
}
	
event::attach(eventMissionInfo, Autobeacon::OnLoad);

function AutoBeacon::OnTeam(%client, %team) {
	if (%client == getmanagerid())
		loadbeacongui("config\\autobeacon\\" @ $servermission @ "team" @ %team @ "beacons.gui");
}
event::attach(eventClientChangeTeam, Autobeacon::OnTeam);

function AutoBeacon::Toggle() {
	if ($Beacon::On) {
		if ($Beacon::Loaded) Deletebeacons();
		$Beacon::On = false;
		remotecp(2048, "<f1>AutoBeacon Status is: <f2>OFF", 1);
	} else {
		$Beacon::On = true;
		loadbeacongui("config\\autobeacon\\" @ $servermission @ "team" @ client::getteam(getmanagerid()) @ "beacons.gui");
		remotecp(2048, "<f1>AutoBeacon Status is: <f2>ON", 1);
	}	
}

if ($Beacon::Modifier == "") {
	editactionmap("Playmap.sae");
	bindcommand(keyboard0, make, $Beacon::Key, TO, "AutoBeacon::Toggle();");
} else {
	editactionmap("Playmap.sae");
	bindcommand(keyboard0, make, $Beacon::Modifier, $Beacon::Key, TO, "AutoBeacon::Toggle();");
}